<?php
namespace Avaliacao\Entities;

use Geral\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;

class AvlLocalavalfilial extends Base\AvlLocalavalfilial
{
    public static function retornaLocaisFilial($nrorg, $cdfilial) {
        $objs = self::getObjectsByWhere(
            'NRORG = ? AND CDFILIAL = ?',
            array(
                $nrorg,
                $cdfilial,
            )
        );

        return $objs;
    }

    public function retornaLocalAvaliacao($nrorg, $cdfilial, $nrlocalavaliacao) {
        $obj = self::getObjectByWhere(
            'NRORG = ? AND CDFILIAL = ? AND NRLOCALAVALIACAO = ?',
            array(
                $nrorg,
                $cdfilial,
                $nrlocalavaliacao,
            )
        );
        return $obj;
    }

    public function incluiLocalFilial($nrorg, $cdfilial, $nrlocalavaliacao) {
        try {
            $obj = new self();
            $obj->setNrorg($nrorg);
            $obj->setCdfilial($cdfilial);
            $obj->setNrlocalavaliacao($nrlocalavaliacao);
            $obj->setDtinclusao(DateUtil::getDataAtual());
            $obj->setNrlocalavalfilial(NovoCodigo::geraCodigo($nrorg, 'AVL_LOCALAVALFILIAL',1,10,true));
            $obj->setNrorginclusao($nrorg);
            $obj->setDtinclusao(DateUtil::getDataAtual());
            $obj->setNrorgultatu($nrorg);
            $obj->setIdativo('S');
            $obj->persist();

            Registry::getEntityManager()->flush();

        } catch (\Exception $e) {
            tk_warning('Erro '.$e->getMessage());
        }
    }
}