package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class PesoProdutoUnidadePage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaPesoProdutoUnidade = By.xpath("//span[text() = 'Peso do Produto na Unidade']");

    By unidadeDepositoBc129 = By.xpath("//div[@data-zh-id=\"4526938862706767285688\"]//div[@class=\"list-items show-select\"]//span[text() = '9999 | DEPOSITO BC 129']");
    By botaoAplicarFiltro = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    By iconeDaLupa = By.xpath("//div[@class=\"control-handle\"]");
    By lupaParaProcurar = By.xpath("//span[@class=\"action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By campoPesoProdutoLinha1 = By.xpath("//div[@class=\"body-content\"]//div[@class=\"tr cell1\"]//div[@data-zh-field-name=\"VRPESOUNIDFI\"]//div[@class=\"editable-content\"]");
    By valorPesoProduto = By.xpath("//div[@class=\"body-content\"]/div[1]/div[3]/span");
    By produtoSpongia = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'SPONGIA TOSTA TM']");

    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Peso do Produto na Unidade");
        click(opcaoTelaPesoProdutoUnidade);
    }

    public void selecionarUnidadeDepositoBc129() {
        click(unidadeDepositoBc129);
        click(botaoAplicarFiltro);
    }

    public void procurarProduto() {
        tempo();
        click(iconeDaLupa);
        click(lupaParaProcurar);
        sendKeys(campoProcurar, "SPONGIA TOSTA TM");
        tempo();

        Actions actions = new Actions(driver);
        actions.click(driver.findElement(campoPesoProdutoLinha1)).build().perform();
        tempo();
        actions.sendKeys("5,85").build().perform();
        actions.sendKeys(Keys.ENTER).build().perform();
        click(botaoSalvarAlteracoes);

        tempo();
        String pesoProduto = getText(valorPesoProduto);
        Assert.assertEquals(pesoProduto, "5,850", "Verificação do peso do produto");
    }

    public void editarValorDoPeso() {
        Actions actions = new Actions(driver);
        actions.click(driver.findElement(campoPesoProdutoLinha1)).build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE);
        actions.sendKeys("6,74");
        actions.sendKeys(Keys.ENTER).build().perform();
        click(botaoSalvarAlteracoes);
        tempo();

        String pesoProduto = getText(valorPesoProduto);
        Assert.assertEquals(pesoProduto, "6,740", "Verificação do peso do produto após a edição");
    }

    public void apagarValorDoPeso() {
        Actions actions = new Actions(driver);
        actions.click(driver.findElement(campoPesoProdutoLinha1)).build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE);
        actions.sendKeys(Keys.ENTER).build().perform();
        click(botaoSalvarAlteracoes);
        tempo();

        String pesoProduto = getText(valorPesoProduto);
        Assert.assertEquals(pesoProduto, "", "Verificação do peso do produto após apagar o valor");
    }

}
